DECLARE FUNCTION KeyValue$ (origkey$)
DECLARE FUNCTION Dec16& (textval$)
DECLARE FUNCTION Enc16$ (value%)
DECLARE SUB AddLog (Text AS STRING)

TYPE Registers
     ax AS INTEGER
     bx AS INTEGER
     cx AS INTEGER
     dx AS INTEGER
     bp AS INTEGER
     si AS INTEGER
     di AS INTEGER
     flags AS INTEGER
     ds AS INTEGER
     es AS INTEGER
END TYPE

'Define custom data type for nTCP-related data.
TYPE nTCP
	Enabled AS INTEGER
	IntVector AS INTEGER
	ErrorCode AS INTEGER
	LocalIP AS LONG
	LocalNetmask AS LONG
	LocalGateway AS LONG
	LocalDNS AS LONG
	LocalDomain AS STRING * 256
	DomainLen AS INTEGER
	Timeserver AS LONG
	MTU AS INTEGER
	TTL AS INTEGER
	TOS AS INTEGER
	MSS AS INTEGER
	RWIN AS INTEGER
	FreeInputPkts AS INTEGER
	FreeOutputPkts AS INTEGER
	Timeout AS INTEGER
END TYPE

'Define custom error type constants and other frequently used values.
CONST errBadCall = 1
CONST errCritical = 2
CONST errNoHandles = 3
CONST errBadHandle = 4
CONST errTimeout = 5
CONST errBadSession = 6

CONST sckListening = 1
CONST sckOpen = 4
CONST sckClosed = 7

DECLARE FUNCTION Conv2IP$ (DWord AS LONG)
DECLARE FUNCTION Conv2DWord$ (inString AS STRING)
DECLARE FUNCTION HighByte% (Word AS INTEGER)
DECLARE FUNCTION LowByte% (Word AS INTEGER)

DECLARE FUNCTION tcpInit% (Vector AS INTEGER)
DECLARE FUNCTION tcpConnect% (RemoteIP AS STRING, RemotePort AS INTEGER)
DECLARE FUNCTION tcpStatus% (tcpHandle AS INTEGER)
DECLARE FUNCTION MakeReg% (h AS INTEGER, l AS INTEGER)
DECLARE FUNCTION tcpListen% (ListenPort AS INTEGER)
DECLARE SUB AddBuffer (textadd AS STRING)
DECLARE SUB DrawScreen ()
DECLARE SUB tcpUnload ()
DECLARE SUB tcpSetTimeout (TimeoutSeconds AS INTEGER)
DECLARE SUB RegBlank ()
DECLARE FUNCTION tcpGetData$ (tcpHandle AS INTEGER)
DECLARE SUB tcpClose (tcpHandle AS INTEGER)
DECLARE FUNCTION tcpInBuffer% (tcpHandle AS INTEGER)
DECLARE FUNCTION tcpInputQueue% (tcpHandle AS INTEGER)
DECLARE FUNCTION tcpRemoteIP$ (tcpHandle AS INTEGER)
DECLARE SUB tcpSendData (tcpHandle AS INTEGER, Data2Send AS STRING)
DECLARE SUB tcpDoIO ()
DECLARE SUB showErrorMsg ()

DECLARE SUB interruptx (intnum AS INTEGER, inreg AS Registers, outreg AS Registers)

'The debugShowReturn subroutine simply prints all the register values
'stored in tcpReturn to the screen. You really shouldn't have any reason
'to use it unless you are curious about the specifics behind NTCPDRV.
'It is mainly here for my own purposes.
DECLARE SUB debugShowReturn ()

DEFINT A-Z

'Dimension variables that are shared between all subroutines and functions.
DIM SHARED tcpCall AS Registers
DIM SHARED tcpReturn AS Registers
DIM SHARED tcpDriver AS nTCP
DIM SHARED isActive AS INTEGER
DIM SHARED strGetData AS STRING * 4096
DIM SHARED strSendData AS STRING * 1500

DIM SHARED state AS INTEGER
DIM SHARED Buffer AS STRING

DIM bincode$
DIM srcseg%, dstseg%, srcoff%, dstoff%, copylen%

'This makes all CPU-blocking calls timeout after 5 seconds.
tcpSetTimeout 5

dummy% = tcpInit%(&H61)
CLS
PRINT "DOSVNC pre-release by Mike Chambers"
PRINT "Written in QuickBASIC 7.1 PDS"
'PRINT
'PRINT "Loading MEMCOPY.BIN...";
'OPEN "memcopy.bin" FOR BINARY AS #1
'bincode$ = SPACE$(LOF(1))
'GET #1, , bincode$
'PRINT " OK!" + STR$(LOF(1)) + " bytes."
'CLOSE #1

PRINT
LINE INPUT "VNC host: ", host$
INPUT "VNC port: ", rport%
INPUT "VNC disp: ", disp%
PRINT
offs = 0
IF host$ = "" THEN host$ = "192.168.1.105"
IF rport% = 0 THEN rport% = 5900
'FOR n = 0 TO 27
	tcpClose 0 'n
'NEXT n
hand% = tcpConnect(host$, rport%)
DO
	SELECT CASE tcpStatus(hand%)
	CASE sckClosed, 0
		SCREEN 0: COLOR 7, 0
		PRINT "Server disconnected!"
		tcpClose hand%
		END
	END SELECT

	DO
		IF LEN(Buffer) > 16000 THEN EXIT DO
		indat$ = tcpGetData(hand%)
		IF indat$ = "" THEN EXIT DO
		Buffer = Buffer + indat$ ': PRINT indat$; STR$(LEN(indat$))
		IF Buffer <> "" THEN
			IF COMMAND$ = "/DEBUG" THEN
				PRINT Buffer
				FOR n = 1 TO LEN(Buffer)
					PRINT ASC(MID$(Buffer, n, 1));
				NEXT n
				PRINT
			END IF
		END IF
	LOOP

	IF Buffer <> "" THEN
		SELECT CASE state
		CASE 0 'version numbers
			IF INSTR(1, Buffer, CHR$(10)) THEN
				cur$ = LEFT$(Buffer, 11)
				Buffer = MID$(Buffer, 13)
				PRINT "Server version: " + cur$
				PRINT "Sending version RFB 003.003 client message."
				tcpSendData hand%, "RFB 003.003" + CHR$(10)
				state = 1
			END IF

		CASE 1
			secval = ASC(MID$(Buffer, 4, 1))
			SELECT CASE secval
			CASE 1 'no authentication
				PRINT "Server reports no authentication required! Continuing..."
				tcpSendData hand%, CHR$(1)
				state = 2

			CASE 2 'VNC authentication
				tcpClose hand%
				PRINT "The server requires authentication. Unfortunately, this is not supported yet."
				PRINT "Exiting to DOS."
				PRINT
				PRINT "Gimme a break, this is a QuickBASIC app. ;)"
				END

			CASE ELSE 'some kind of error
				tcpClose hand%
				PRINT "The server had reported some sort of error. Exiting to DOS."
				END
			END SELECT
			'PRINT "Requesting non-shared session."
			'tcpSendData hand%, CHR$(0)
			Buffer = MID$(Buffer, 6)
			'Buffer = ""
			state = 2

		CASE 2
			PRINT
			PRINT "Got ServerInit message:"
			sw% = (ASC(MID$(Buffer, 1, 1)) * 256) + ASC(MID$(Buffer, 2, 1)): Buffer = MID$(Buffer, 3)
			sh% = (ASC(MID$(Buffer, 1, 1)) * 256) + ASC(MID$(Buffer, 2, 1)): Buffer = MID$(Buffer, 3)
			spft$ = LEFT$(Buffer, 16): Buffer = MID$(Buffer, 17)
			namelen& = (ASC(MID$(Buffer, 3, 1)) * 256) + ASC(MID$(Buffer, 4, 1))
			Buffer = MID$(Buffer, 5)
			servername$ = LEFT$(Buffer, namelen&)
			Buffer = ""
			PRINT "Host desktop:" + STR$(sw%) + " x" + STR$(sh%)
			PRINT "Host title: " + servername$
			PRINT
			PRINT "Sending pixel format request type..."
			ob$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
			ob$ = ob$ + CHR$(8) + CHR$(8) + CHR$(0) + CHR$(1)
			ob$ = ob$ + CHR$(1) + CHR$(0) + CHR$(1) + CHR$(0) + CHR$(1) + CHR$(0)
			ob$ = ob$ + CHR$(0) + CHR$(1) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
			tcpSendData hand%, ob$: ob$ = ""
			PRINT "Sending encodings request type... (RAW, RRE)"
			tcpSendData hand%, CHR$(2) + CHR$(0) + CHR$(0) + CHR$(2) + STRING$(7, CHR$(0)) + CHR$(2)
			PRINT
			IF INSTR(1, COMMAND$, "/INFO") THEN offs = 16 ELSE offs = 0
			vpw = 640
			vph = 480 - offs
			IF vpw > sw% THEN vpw = sw%
			IF vph > sh% THEN vph = sh%

			PRINT "DOSVNC will limit the viewport to" + STR$(vpw) + "x" + MID$(STR$(vph), 2) + "."
			PRINT
			PRINT "Press a key to continue, or wait 15 seconds..."
			t! = TIMER
			DO: LOOP UNTIL INKEY$ <> "" OR TIMER - t! > 15

			SCREEN 12: PALETTE
			rat! = INT(255 / 15)
			tcpSendData hand%, CHR$(3) + CHR$(0) + Enc16$(0) + Enc16$(0) + Enc16$(vpw) + Enc16$(vph)
			state = 3

		CASE 3
			'LOCATE 1, 1
			'PRINT Buffer
			'DO: LOOP UNTIL INKEY$ <> ""
			msgtype% = ASC(LEFT$(Buffer, 1))
			SELECT CASE msgtype%
				CASE 0 'framebuffer update
					Buffer = MID$(Buffer, 3)
					rects& = Dec16(LEFT$(Buffer, 2))
					Buffer = MID$(Buffer, 3)
					'PRINT rects&; "<--total rectangles in packet"
					'DO: LOOP UNTIL INKEY$ <> ""
						IF LEN(Buffer) < 16000 THEN
							indat$ = tcpGetData(hand%)
							Buffer = Buffer + indat$': PRINT indat$; STR$(LEN(indat$))
						END IF

					FOR nu = 1 TO rects&
						sx& = Dec16(LEFT$(Buffer, 2))
						sy& = Dec16(MID$(Buffer, 3, 2))
						wi& = Dec16(MID$(Buffer, 5, 2))
						he& = Dec16(MID$(Buffer, 7, 2))
						enc& = ASC(MID$(Buffer, 12, 1))
						Buffer = MID$(Buffer, 13)

						SELECT CASE enc&
							CASE 0
								encmeth$ = "Raw"
							CASE 2
								encmeth$ = "RRE"
						END SELECT

						IF offs > 0 THEN
							COLOR 15
							LOCATE 1, 1
							PRINT LEFT$(servername$ + " from" + STR$(sx&) + "x" + MID$(STR$(sy&), 2) + "-" + MID$(STR$(sx& + wi& - 1), 2) + "x" + MID$(STR$(sy& - he&), 2) + " - Encoding: " + encmeth$ + " (" + MID$(STR$( _
vpw), 2) + "x" + MID$(STR$(vph), 2) + " viewport)" + SPACE$(80), 80);
						END IF
						'IF sx& <= 640 AND sy& <= 472 THEN
						SELECT CASE enc&
						CASE 0 'raw encoding
						IF sx& <= vpw AND sy& <= vph THEN
							FOR cy& = sy& + offs TO sy& + he& + offs - 1
							IF LEN(Buffer) < 16000 THEN
								indat$ = tcpGetData(hand%)
								Buffer = Buffer + indat$': PRINT indat$; STR$(LEN(indat$))
							END IF
							key$ = INKEY$
							IF key$ <> "" THEN kbuf$ = kbuf$ + CHR$(LEN(key$)) + key$
							IF kbuf$ <> "" THEN GOSUB kbufhandle:

							'srcseg% = VARSEG(Buffer)
							'srcoff% = VARPTR(Buffer)
							'dstseg% = &HA000
							'dstoff% = (320 * cy&) + sx&
							'copylen% = INT(wi&)
							'GOSUB memcopy:

							cbp& = 1
							FOR cx& = sx& TO sx& + wi& - 1
								PSET (cx&, cy&), ASC(MID$(Buffer, cbp&, 1)) / rat!
								cbp& = cbp& + 1
							NEXT cx&
							Buffer = MID$(Buffer, wi& + 1)
							NEXT cy&
						ELSE
							Buffer = MID$(Buffer, (he& * wi&) + 1)
						END IF

						CASE 2 'RRE encoding
							subrect& = (Dec16(LEFT$(Buffer, 2)) * 65536) + Dec16(MID$(Buffer, 3, 2))
							bgpix = ASC(MID$(Buffer, 5, 1))
							Buffer = MID$(Buffer, 6)
							LINE (sx&, sy&)-(sx& + wi& - 1, sy& + he& - 1), bgpix, BF
							FOR num = 1 TO subrect&
								spv = ASC(LEFT$(Buffer, 1))
								sxp& = Dec16(MID$(Buffer, 2, 2))
								syp& = Dec16(MID$(Buffer, 4, 2))
								srw& = Dec16(MID$(Buffer, 6, 2))
								srh& = Dec16(MID$(Buffer, 8, 2))
								Buffer = MID$(Buffer, 10)
								LINE (sx& + sxp&, sy& + syp&)-(sx& + sxp& + srw& - 1, sy& + syp& + srh& - 1), spv, BF
							NEXT num
						END SELECT
					NEXT nu
					'PRINT "lol"
					'DO: LOOP UNTIL INKEY$ <> ""

				CASE 1 'setcolormapentries
					Buffer = MID$(Buffer, 3)
						IF LEN(Buffer) < 16000 THEN
							indat$ = tcpGetData(hand%)
							Buffer = Buffer + indat$': PRINT indat$; STR$(LEN(indat$))
						END IF

					first& = Dec16(LEFT$(Buffer, 2)): Buffer = MID$(Buffer, 3)
					colors& = Dec16(LEFT$(Buffer, 2)): Buffer = MID$(Buffer, 3)
					ratio! = 255 / 63
					FOR nu = first& TO first& + colors& - 1
						r& = INT(Dec16(LEFT$(Buffer, 2)) / ratio!)
						g& = INT(Dec16(MID$(Buffer, 3, 2)) / ratio!)
						b& = INT(Dec16(MID$(Buffer, 5, 2)) / ratio!)
						Buffer = MID$(Buffer, 7)
						IF r& > 63 THEN r& = 63
						IF g& > 63 THEN g& = 63
						IF b& > 63 THEN b& = 63
						'PRINT nu; r&; g&; b&
						PALETTE nu, r& + (g& * 256) + (b& * 65536)
					NEXT nu
					'PRINT "set entries"
					'DO: LOOP UNTIL INKEY$ <> ""

				CASE 2 'ring bell
					BEEP
					Buffer = MID$(Buffer, 2)
			END SELECT

		CASE ELSE
			PRINT Buffer
			PRINT STR$(LEN(Buffer))
			'Buffer = ""
		END SELECT
	END IF

	IF state = 3 AND LEN(Buffer) < 16000 THEN tcpSendData hand%, CHR$(3) + CHR$(1) + Enc16$(0) + Enc16$(0) + Enc16$(vpw) + Enc16$(vph)
	GOSUB kbufhandle:
	'LOOP
LOOP
END

kbufhandle:
key$ = INKEY$
IF key$ <> "" THEN kbuf$ = kbuf$ + CHR$(LEN(key$)) + key$
DO UNTIL kbuf$ = ""
	ln = 0
	IF kbuf$ <> "" THEN
		ln = ASC(LEFT$(kbuf$, 1))
	END IF
	ckey$ = MID$(kbuf$, 2, ln)
	SELECT CASE ckey$
		CASE ""
		CASE CHR$(0) + CHR$(1) 'alt+esc exits
			tcpClose hand%
			END

		CASE ELSE 'otherwise send keypress command to vnc server
			kv$ = KeyValue(ckey$)
			ob$ = CHR$(4) + CHR$(1) + CHR$(0) + CHR$(0) + kv$
			ob$ = ob$ + CHR$(4) + CHR$(0) + CHR$(0) + CHR$(0) + kv$
			tcpSendData hand%, ob$
			ob$ = ""
	END SELECT
	kbuf$ = MID$(kbuf$, 2 + ln)
LOOP
RETURN

memcopy:
CALL absolute(srcseg%, dstseg%, srcoff%, dstoff%, copylen%, VARPTR(bincode$))
RETURN

DEFSNG A-Z
FUNCTION Conv2DWord$ (inString AS STRING)
'The inString variable should be an IPv4 address in the standard
'format of x.x.x.x

DIM tempArray(3) AS STRING * 1
DIM tempVal AS INTEGER

tempVal = INSTR(1, inString, ".")
IF tempVal THEN
	tempArray(0) = CHR$(VAL(LEFT$(inString, tempVal)))
	inString = MID$(inString, tempVal + 1)
ELSE
	EXIT FUNCTION
END IF

tempVal = INSTR(1, inString, ".")
IF tempVal THEN
	tempArray(1) = CHR$(VAL(LEFT$(inString, tempVal)))
	inString = MID$(inString, tempVal + 1)
ELSE
	EXIT FUNCTION
END IF

tempVal = INSTR(1, inString, ".")
IF tempVal THEN
	tempArray(2) = CHR$(VAL(LEFT$(inString, tempVal)))
	inString = MID$(inString, tempVal + 1)
ELSE
	EXIT FUNCTION
END IF

tempArray(3) = CHR$(VAL(inString))
Conv2DWord$ = tempArray(0) + tempArray(1) + tempArray(2) + tempArray(3)
END FUNCTION

FUNCTION Conv2IP$ (DWord AS LONG)
DIM tempStr AS STRING * 4

tempStr = MKL$(DWord)
Conv2IP$ = MID$(STR$(ASC(LEFT$(tempStr, 1))), 2) + "." + MID$(STR$(ASC(MID$(tempStr, 2, 1))), 2) + "." + MID$(STR$(ASC(MID$(tempStr, 3, 1))), 2) + "." + MID$(STR$(ASC(RIGHT$(tempStr, 1))), 2)
END FUNCTION

SUB debugShowReturn
PRINT "   ax:" + STR$(tcpReturn.ax) + " (" + HEX$(tcpReturn.ax) + "h)"
PRINT "   bx:" + STR$(tcpReturn.bx) + " (" + HEX$(tcpReturn.bx) + "h)"
PRINT "   cx:" + STR$(tcpReturn.cx) + " (" + HEX$(tcpReturn.cx) + "h)"
PRINT "   dx:" + STR$(tcpReturn.dx) + " (" + HEX$(tcpReturn.dx) + "h)"
PRINT "   bp:" + STR$(tcpReturn.bp) + " (" + HEX$(tcpReturn.bp) + "h)"
PRINT "   si:" + STR$(tcpReturn.si) + " (" + HEX$(tcpReturn.si) + "h)"
PRINT "   di:" + STR$(tcpReturn.di) + " (" + HEX$(tcpReturn.di) + "h)"
PRINT "flags:" + STR$(tcpReturn.flags) + " (" + HEX$(tcpReturn.flags) + "h)"
PRINT "   ds:" + STR$(tcpReturn.ds) + " (" + HEX$(tcpReturn.ds) + "h)"
PRINT "   es:" + STR$(tcpReturn.es) + " (" + HEX$(tcpReturn.es) + "h)"
END SUB

DEFINT A-Z
FUNCTION Dec16& (textval$)
'textval$ = LEFT$(textval$ + CHR$(0) + CHR$(0), 2)
Dec16& = (ASC(MID$(textval$, 1, 1)) * 256) + ASC(MID$(textval$, 2, 1))
END FUNCTION

FUNCTION Enc16$ (value%)
hv% = FIX(value / 256)
lv% = value - (hv% * 256)
Enc16$ = CHR$(hv%) + CHR$(lv%)
END FUNCTION

DEFSNG A-Z
FUNCTION HighByte% (Word AS INTEGER)
HighByte% = ASC(RIGHT$(MKI$(Word), 1))
END FUNCTION

DEFINT A-Z
FUNCTION KeyValue$ (origkey$)
ON ERROR RESUME NEXT: cv = ASC(origkey$)
ev = 0
SELECT CASE cv
	CASE 0
	CASE 8, 9, 13, 27
		ev = 255
		nv = cv
	CASE ELSE
		nv = cv
END SELECT
KeyValue$ = CHR$(0) + CHR$(0) + CHR$(ev) + CHR$(nv)
END FUNCTION

DEFSNG A-Z
FUNCTION LowByte% (Word AS INTEGER)
LowByte% = ASC(LEFT$(MKI$(Word), 1))
END FUNCTION

FUNCTION MakeReg% (h AS INTEGER, l AS INTEGER)
MakeReg% = CVI(CHR$(l) + CHR$(h))
END FUNCTION

SUB RegBlank
tcpCall.ax = 0
tcpCall.bx = 0
tcpCall.cx = 0
tcpCall.dx = 0
tcpCall.bp = 0
tcpCall.si = 0
tcpCall.di = 0
tcpCall.flags = 0
tcpCall.ds = 0
tcpCall.es = 0
END SUB

SUB showErrorMsg
PRINT "ERROR CODE" + STR$(tcpDriver.ErrorCode) + "!!! ";
SELECT CASE tcpDriver.ErrorCode
	CASE errBadCall
		PRINT "err_badcall"
	CASE errCritical
		PRINT "err_critical"
	CASE errNoHandles
		PRINT "err_nohandles"
	CASE errBadHandle
		PRINT "err_badhandle"
	CASE errTimeout
		PRINT "err_timeout"
	CASE errBadSession
		PRINT "err_badsession"
END SELECT
END SUB

SUB tcpClose (tcpHandle AS INTEGER)
tcpCall.ax = MakeReg(&H11, 1)
tcpCall.bx = tcpHandle
tcpCall.dx = tcpDriver.Timeout

CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
tcpDoIO
END SUB

FUNCTION tcpConnect% (RemoteIP AS STRING, RemotePort AS INTEGER)
DIM tempRemoteIP AS STRING
tempRemoteIP = Conv2DWord(RemoteIP)

tcpCall.ax = MakeReg(&H10, 0)
tcpCall.bx = 0
tcpCall.cx = RemotePort
tcpCall.dx = tcpDriver.Timeout
tcpCall.di = CVI(LEFT$(tempRemoteIP, 2))
tcpCall.si = CVI(RIGHT$(tempRemoteIP, 2))
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

dummyLocalPortNr% = tcpReturn.ax
'PRINT "Local port:"; dummyLocalPortNr%

tcpConnect% = tcpReturn.bx 'Makes this function return the TCPDRV handle number.
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)

tcpDoIO
END FUNCTION

SUB tcpDoIO
'Allows TCPDRV to perform processing of data. THIS MUST BE CALLED REGULARLY
'for packets to be processed! If you don't do this, TCPDRV will eventually
'crash when it runs out of storage space for input and output queues.

'RegBlank

tcpCall.ax = MakeReg(&H2, 0)
tcpCall.dx = 0 'tcpDriver.Timeout
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END SUB

FUNCTION tcpGetData$ (tcpHandle AS INTEGER)
tcpCall.ax = MakeReg(&H12, 1)
tcpCall.bx = tcpHandle
tcpCall.es = VARSEG(strGetData)
tcpCall.di = VARPTR(strGetData)
tcpCall.cx = 4096
tcpCall.dx = tcpDriver.Timeout
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)
tcpGetData$ = LEFT$(strGetData, tcpReturn.ax)

tcpDriver.ErrorCode = LowByte(tcpReturn.dx)

tcpDoIO
END FUNCTION

FUNCTION tcpInBuffer% (tcpHandle AS INTEGER)
dummy1% = tcpStatus%(tcpHandle)
IF isActive > 0 THEN
	tcpInBuffer% = tcpReturn.ax
END IF
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

FUNCTION tcpInit% (Vector AS INTEGER)
'If given vector value is zero, assume the usual vector 61h.
IF Vector = 0 THEN Vector = &H61

tcpCall.ax = MakeReg(&H0, &HFF)
CALL interruptx(Vector, tcpCall, tcpReturn)

'This next line sets tcpDriver.Enabled to zero, sets the tcpInit function
'return value to zero, and exits the function immediately if the interrupt
'call did not return the expected value of zero for a functional TCPDRV
'vector at the specified segment.
IF tcpReturn.ax <> 0 THEN tcpDriver.Enabled = 0: tcpInit% = 0: EXIT FUNCTION

tcpInit% = 1
tcpDriver.Enabled = 1
tcpDriver.IntVector = Vector
DEF SEG = tcpReturn.es
offset = tcpReturn.di

'The following lines of code parse all of the network-related data
'from the pointer value returned by TCPDRV.
tcpDriver.LocalIP = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.LocalNetmask = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.LocalGateway = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.LocalDNS = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.Timeserver = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.MTU = CVI(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)))
offset = offset + 2

tcpDriver.TTL = PEEK(offset)
tcpDriver.TOS = PEEK(offset + 1)
offset = offset + 4 'Skip two unused bytes after TTL and TOS data.

tcpDriver.MSS = CVI(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)))
offset = offset + 2

tcpDriver.RWIN = CVI(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)))
offset = offset + 4 'Skip two unused bytes after RWIN data.

'The following code segment gets the local domain string.
DIM tempNum AS INTEGER
DIM tempCurByte AS STRING * 1
DIM tempStr AS STRING
FOR tempNum = offset TO offset + 255
	tempCurByte = CHR$(PEEK(tempNum))
	IF tempCurByte = CHR$(255) THEN
		tcpDriver.DomainLen = tempNum - offset
		tcpDriver.LocalDomain = tempStr
	ELSE
		tempStr = tempStr + tempCurByte
	END IF
NEXT tempNum

tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

FUNCTION tcpListen% (ListenPort AS INTEGER)
tcpCall.ax = MakeReg(&H10, 1)
tcpCall.bx = ListenPort
tcpCall.cx = 0
tcpCall.dx = tcpDriver.Timeout
tcpCall.si = 0
tcpCall.di = 0
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

tcpListen% = tcpReturn.bx
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)

tcpDoIO
END FUNCTION

DEFINT A-Z
FUNCTION tcpRemoteIP$ (tcpHandle AS INTEGER)
checkstat% = tcpStatus(tcpHandle)
IF checkstat% <> sckOpen THEN tcpRemoteIP$ = "0.0.0.0": EXIT FUNCTION

DEF SEG = tcpReturn.es
stateoffset = tcpReturn.di
ipdest$ = Conv2IP(CVL(CHR$(PEEK(stateoffset + 6)) + CHR$(PEEK(stateoffset + 7)) + CHR$(PEEK(stateoffset + 8)) + CHR$(PEEK(stateoffset + 9))))
'ipsrce$ = Conv2IP(CVL(CHR$(PEEK(stateoffset)) + CHR$(PEEK(stateoffset + 1)) + CHR$(PEEK(stateoffset + 2)) + CHR$(PEEK(stateoffset + 3))))

tcpRemoteIP$ = ipdest$
END FUNCTION

DEFSNG A-Z
SUB tcpSendData (tcpHandle AS INTEGER, Data2Send AS STRING)
'DO UNTIL Data2Send = ""
	strSendData = LEFT$(Data2Send, 1500)
	sendsize = LEN(Data2Send)
	'IF sendsize > 512 THEN sendsize = 512: Data2Send = MID$(Data2Send, 513)

	tcpCall.ax = MakeReg(&H13, 4)
	tcpCall.bx = tcpHandle
	tcpCall.es = INT(VARSEG(strSendData))
	tcpCall.di = INT(VARPTR(strSendData))
	tcpCall.cx = sendsize
	tcpCall.dx = tcpDriver.Timeout
	CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

	tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
	tcpDoIO
'LOOP
END SUB

SUB tcpSetTimeout (TimeoutSeconds AS INTEGER)
tcpDriver.Timeout = INT(TimeoutSeconds * 18.2)
END SUB

FUNCTION tcpStatus% (tcpHandle AS INTEGER)
tcpCall.ax = MakeReg(&H14, 0)
tcpCall.bx = tcpHandle
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

DEF SEG = tcpReturn.es
stateoffset = tcpReturn.di
ipsrce$ = Conv2IP(CVL(CHR$(PEEK(stateoffset)) + CHR$(PEEK(stateoffset + 1)) + CHR$(PEEK(stateoffset + 2)) + CHR$(PEEK(stateoffset + 3))))
ipdest$ = Conv2IP(CVL(CHR$(PEEK(stateoffset + 4)) + CHR$(PEEK(stateoffset + 5)) + CHR$(PEEK(stateoffset + 6)) + CHR$(PEEK(stateoffset + 7))))
ipprot% = PEEK(stateoffset + 8)
active% = PEEK(stateoffset + 9)
ifActive = active%
'PRINT "======================"
'PRINT "Debug: Status data return values for TCP handle"; tcpHandle
'PRINT
'PRINT "Error code:"; LowByte(tcpReturn.dx)
'PRINT "TCP state:"; HighByte(tcpReturn.dx)
'PRINT
'PRINT "Bytes available for reading:"; tcpReturn.ax
'PRINT "Bytes still being transmitted:"; tcpReturn.cx
'PRINT
'PRINT "Session info gathered from pointer" + STR$(tcpReturn.es) + ":" + MID$(STR$(tcpReturn.di), 2)
'PRINT "IP source: " + ipsrce$
'PRINT "IP dest: " + ipsrce$
'PRINT "IP prot:"; ipprot%
'PRINT "Active:"; active%
'PRINT "======================"
tcpStatus% = HighByte(tcpReturn.dx)
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

SUB tcpUnload
tcpCall.ax = MakeReg(&H1, 0)
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

tcpDriver.Enabled = 0
END SUB

